/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /builds/tinderbox/XR-Trunk/Linux_2.6.18-8.el5_Depend/mozilla/toolkit/components/places/public/nsITaggingService.idl
 */

package org.mozilla.interfaces;

public interface nsITaggingService extends nsISupports {

  String NS_ITAGGINGSERVICE_IID =
    "{3acd6c94-232b-4ac4-b99e-0631b7e96ed9}";

  /**
   * Tags a URL with the given set of tags. Current tags set for the URL
   * persist. Tags in aTags which are already set for the given URL are
   * ignored.
   *
   * @param aURI
   *        the URL to tag.
   * @param aTags
   *        Array of tags to set for the given URL.
   */
  void tagURI(nsIURI aURI, nsIVariant aTags);

  /**
   * Removes tags from a URL. Tags from aTags which are not set for the
   * given URL are ignored.
   *
   * @param aURI
   *        the URL to un-tag.
   * @param aTags
   *        Array of tags to unset. pass null to remove all tags from the given
   *        url.
   */
  void untagURI(nsIURI aURI, nsIVariant aTags);

  /**
   * Retrieves all URLs tagged with the given tag.
   *
   * @param aTag
   *        tag name
   * @returns Array of uris tagged with aTag.
   */
  nsIVariant getURIsForTag(String aTag);

  /**
   * Retrieves all tags set for the given URL.
   *
   * @param aURI
   *        a URL.
   * @returns array of tags (sorted by name).
   */
  nsIVariant getTagsForURI(nsIURI aURI);

  /**
   * Retrieves all tags used to tag URIs in the data-base (sorted by name).
   */
  nsIVariant getAllTags();

  /**
   * Retrieves the URL spec for the tag container icon
   */
  String getTagContainerIconSpec();

}